#include <string.h>
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"

SDL_Surface *ball = NULL;
SDL_Surface *background = NULL;
SDL_Surface *screen = NULL;

using std::string;
string filename = NULL;

SDL_Surface *load_image( filename ) 
{
     //The image that's loaded
     SDL_Surface* loadedImage = NULL;
   
     //The optimized image that will be used
     SDL_Surface* optimizedImage = NULL;
     
     //Load the image using SDL_image
     loadedImage = IMG_Load( filename.c_str() );
     
     //If the image loaded
     if( loadedImage != NULL )
     {
    //Create an optimized image
    optimizedImage = SDL_DisplayFormat( loadedImage );
        
    //Free the old image
    SDL_FreeSurface( loadedImage );
     }
    
      //Return the optimized image
      return optimizedImage;
}

void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
{
    //Make a temporary rectangle to hold the offsets
    SDL_Rect offset;
    
    //Give the offsets to the rectangle
    offset.x = x;
    offset.y = y;
    //Blit the surface
    SDL_BlitSurface( source, NULL, destination, &offset );
}

int main(int argc, char* argv[])
{

//############################################################################################
// RENDER
//############################################################################################

    //Initialize all SDL subsystems
    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return 1;    
    }
    //Set up the screen
    screen = SDL_SetVideoMode( 480, 640, 16, SDL_SWSURFACE );
    //If there was an error in setting up the screen
    if( screen == NULL )
    {
        return 1;    
    }
    //Set the window caption
    SDL_WM_SetCaption( "Labyrinth", NULL );

    //Load the images
    ball = load_image( PIXMAPDIR"/ball.png" );
    background = load_image( PIXMAPDIR"/bg.png" );
    //Apply the background to the screen
    apply_surface( 0, 0, background, screen );
    //Apply the ball to the screen
    apply_surface( 180, 140, ball, screen );
    //Update the screen
    if( SDL_Flip( screen ) == -1 )
    {
        return 1;    
    }

    //Wait 2 seconds
    SDL_Delay( 2000 );


    //Free the surfaces
    SDL_FreeSurface( ball );
    SDL_FreeSurface( background );
    
    //Quit SDL
    SDL_Quit();

}



















